pipeline {
    agent any
	
    stages {
		stage('Clean') {
			steps {
				cleanWs()
				dir("${env.WORKSPACE}@tmp") {
				  deleteDir()
				}
				dir("${env.WORKSPACE}@script") {
				  deleteDir()
				}
				dir("${env.WORKSPACE}@script@tmp") {
				  deleteDir()
				}
			}
        }
		stage('Checkout HIP Prod'){
			when {
                branch 'master'
            }
			steps {
				sh "echo '-----------------------PROD----------------------'"
			}
		}
		stage('Checkout HIP Demo'){
			when {
                branch 'develop'
            }
			steps {
				git(
				   url: "git@gitlab.com:innov8tif/innov8tif-ekyc-product/webapp/ekyc-portal.git",
				   credentialsId: "50c2e660-6fcd-474e-b8f9-5f3464a1e03e",
				   branch: "develop"
				)
				sh """
					docker image build -t hip --build-arg PROFILE="ekycportal-prod" .
					#docker container run --name hip -p 8088:8080 -d hip
					
					
					#check API health
					#sleep 30
					.#curl localhost:8088/api/health
					
					#tag staging image to Alibaba container registry namespace with Jenkins buildID tag
					sudo docker tag hip cr-innov8tif-registry-vpc.ap-southeast-3.cr.aliyuncs.com/hip/demo_hip:${BUILD_ID}
					
					#push image to Alibaba container registry 
					sudo docker push cr-innov8tif-registry-vpc.ap-southeast-3.cr.aliyuncs.com/hip/demo_hip:${BUILD_ID}
					
					#tag the image to Alibaba container registry namespace with latest tag
					sudo docker tag cr-innov8tif-registry-vpc.ap-southeast-3.cr.aliyuncs.com/hip/demo_hip:${BUILD_ID} cr-innov8tif-registry-vpc.ap-southeast-3.cr.aliyuncs.com/hip/demo_hip:latest
					
					#push image to Alibaba container registry 
					sudo docker push cr-innov8tif-registry-vpc.ap-southeast-3.cr.aliyuncs.com/hip/demo_hip:latest
					
					#remove the container & image
					#docker container stop hip || true
					#docker container rm hip || true
					sudo docker image rm cr-innov8tif-registry-vpc.ap-southeast-3.cr.aliyuncs.com/hip/demo_hip:latest || true
					sudo docker image rm cr-innov8tif-registry-vpc.ap-southeast-3.cr.aliyuncs.com/hip/demo_hip:${BUILD_ID}  || true	
					sudo docker image rm hip  || true
					docker image prune -f --filter="dangling=true" || true
				"""
			}
		}
    }
	post {
		always {
            emailext to: "jinxuan@innov8tif.com",
            subject: "jenkins build:${currentBuild.currentResult}: ${env.JOB_NAME}",
            body: "${currentBuild.currentResult}: Job ${env.JOB_NAME}\nMore Info can be found here: ${env.BUILD_URL}"
		  }
    }
}
